build_daemon 0.5.0

  • README.md
  • CHANGELOG.md
  • Example
  • Installing
  • Versions
  • 88

This package provides support for running builds in a daemon.

0.5.0 #

  • Add OutputLocation to DefaultBuildTarget.

0.4.2 #

  • Enable configuring the environment for the daemon.

0.4.1 #

  • Support closing a daemon client.
  • Fix a null set bug in the build target manager.

0.4.0 #

  • Replace the client log stream with an optional logHandler. This simplifies the logging logic and prevents the need for the client to print to stdio.

0.3.0 #

  • Forward daemon output while starting up / connecting.

0.2.3 #

  • Shutdown the daemon if no client connects within 30 seconds.

0.2.2 #

  • Resolve client path issues with running on Windows.

0.2.1 #

  • Resolve issues with running on Windows.
    • Close the lock file prior to deleting it.
    • Properly join paths and escape the workspace.

0.2.0 #

  • Support custom build results.
  • Options are no longer dynamic and are provided upon connecting.
  • Report OptionsSkew.
  • Prefix build daemon directory with username.
  • Forward filesystem changes to daemon builder.
  • Support custom build targets.

0.0.1 #

  • Initial Build Daemon support.

example/example.dart

// Copyright (c) 2019, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

import 'dart:io';
import 'dart:math';

import 'package:build_daemon/client.dart';
import 'package:build_daemon/data/build_target.dart';
import 'package:path/path.dart' as p;

void main(List<String> args) async {
  BuildDaemonClient client;
  var workingDirectory =
      p.normalize(p.join(Directory.current.path + '/../example'));

  try {
    client = await BuildDaemonClient.connect(
        workingDirectory,
        [
          'pub',
          'run',
          'build_runner',
          'daemon',
          '--delete-conflicting-outputs',
        ],
        logHandler: print);
  } catch (e) {
    if (e is VersionSkew) {
      print('Version skew. Please disconnect all other clients '
          'before trying to start a new one.');
    } else if (e is OptionsSkew) {
      print('Options skew. Please disconnect all other clients '
          'before trying to start a new one.');
    } else {
      print('Unexpected error: $e');
    }

    exit(1);
  }
  if (client == null) throw Exception('Error connecting');
  print('Connected to Dart Build Daemon');
  if (Random().nextBool()) {
    client.registerBuildTarget(DefaultBuildTarget((b) => b
      ..target = 'web'
      ..outputLocation = OutputLocation((b) => b
        ..output = 'web_output'
        ..useSymlinks = false
        ..hoist = true).toBuilder()
      ..blackListPatterns.replace([RegExp(r'.*_test\.dart$')])));
    print('Registered example web target...');
  } else {
    client.registerBuildTarget(DefaultBuildTarget((b) => b
      ..target = 'test'
      ..outputLocation = OutputLocation((b) => b
        ..output = 'test_output'
        ..useSymlinks = true
        ..hoist = false).toBuilder()));

    print('Registered test target...');
  }
  client.buildResults.listen((status) => print('BUILD STATUS: $status'));
  client.startBuild();
  await client.finished;
}

Use this package as a library

1. Depend on it

Add this to your package's pubspec.yaml file:


dependencies:
  build_daemon: ^0.5.0

2. Install it

You can install packages from the command line:

with pub:


$ pub get

with Flutter:


$ flutter packages get

Alternatively, your editor might support pub get or flutter packages get. Check the docs for your editor to learn more.

3. Import it

Now in your Dart code, you can use:


import 'package:build_daemon/client.dart';
import 'package:build_daemon/constants.dart';
import 'package:build_daemon/daemon_builder.dart';
import 'package:build_daemon/data/build_request.dart';
import 'package:build_daemon/data/build_request.g.dart';
import 'package:build_daemon/data/build_status.dart';
import 'package:build_daemon/data/build_status.g.dart';
import 'package:build_daemon/data/build_target.dart';
import 'package:build_daemon/data/build_target.g.dart';
import 'package:build_daemon/data/build_target_request.dart';
import 'package:build_daemon/data/build_target_request.g.dart';
import 'package:build_daemon/data/serializers.dart';
import 'package:build_daemon/data/serializers.g.dart';
import 'package:build_daemon/data/server_log.dart';
import 'package:build_daemon/data/server_log.g.dart';
  
Version Uploaded Documentation Archive
0.5.0 Mar 26, 2019 Go to the documentation of build_daemon 0.5.0 Download build_daemon 0.5.0 archive
0.4.2 Mar 4, 2019 Go to the documentation of build_daemon 0.4.2 Download build_daemon 0.4.2 archive
0.4.1 Feb 26, 2019 Go to the documentation of build_daemon 0.4.1 Download build_daemon 0.4.1 archive
0.4.0 Feb 13, 2019 Go to the documentation of build_daemon 0.4.0 Download build_daemon 0.4.0 archive
0.3.0 Feb 4, 2019 Go to the documentation of build_daemon 0.3.0 Download build_daemon 0.3.0 archive
0.2.3 Feb 1, 2019 Go to the documentation of build_daemon 0.2.3 Download build_daemon 0.2.3 archive
0.2.2 Jan 29, 2019 Go to the documentation of build_daemon 0.2.2 Download build_daemon 0.2.2 archive
0.2.1 Jan 28, 2019 Go to the documentation of build_daemon 0.2.1 Download build_daemon 0.2.1 archive
0.2.0 Jan 23, 2019 Go to the documentation of build_daemon 0.2.0 Download build_daemon 0.2.0 archive
0.0.1 Jan 7, 2019 Go to the documentation of build_daemon 0.0.1 Download build_daemon 0.0.1 archive
Popularity:
Describes how popular the package is relative to other packages. [more]
83
Health:
Code health derived from static analysis. [more]
100
Maintenance:
Reflects how tidy and up-to-date the package is. [more]
80
Overall:
Weighted score of the above. [more]
88
Learn more about scoring.

We analyzed this package on Apr 16, 2019, and provided a score, details, and suggestions below. Analysis was completed with status completed using:

  • Dart: 2.2.0
  • pana: 0.12.14

Platforms

Detected platforms: Flutter, other

Platform components identified in package: io.

Maintenance suggestions

The package description is too short. (-20 points)

Add more detail to the description field of pubspec.yaml. Use 60 to 180 characters to describe the package, what it does, and its target use case.

Dependencies

Package Constraint Resolved Available
Direct dependencies
Dart SDK >=2.1.0 <3.0.0
built_collection ^4.1.0 4.2.0
built_value ^6.3.0 6.4.0
package_resolver ^1.0.6 1.0.10
path ^1.6.2 1.6.2
pedantic ^1.0.0 1.5.0
pool ^1.3.6 1.4.0
shelf ^0.7.4 0.7.5
shelf_web_socket ^0.2.2+4 0.2.2+5
stream_transform ^0.0.14+1 0.0.17
watcher ^0.9.7 0.9.7+10
web_socket_channel ^1.0.9 1.0.12
Transitive dependencies
async 2.2.0
charcode 1.1.2
collection 1.14.11
convert 2.1.1
crypto 2.0.6
fixnum 0.10.9
http 0.12.0+2
http_parser 3.1.3
matcher 0.12.5
meta 1.1.7
package_config 1.0.5
quiver 2.0.3
source_span 1.5.5
stack_trace 1.9.3
stream_channel 2.0.0
string_scanner 1.0.4
term_glyph 1.1.0
typed_data 1.1.6
Dev dependencies
build_runner ^1.0.0
built_value_generator ^6.2.0
mockito ^4.0.0
test ^1.3.3
test_descriptor ^1.1.1
uuid ^2.0.0